function getTime(){
    var day = new Date();
    return day.getTime();
}

function formatDuration(d,digits) {
    dig = "." + Math.floor(10*(d-Math.floor(d)));
    d = Math.floor( d );
    d = d<0 ? 0 : d;
    var s = d%60;
    var m = Math.floor(d/60) % 60;
    var h = Math.floor(d/3600);
    s = s<10 ? "0"+s : s;
    m = m<10 ? "0"+m : m;
    h = h<10 ? "0"+h : h;
    return h + ":" + m + ":" + s + dig;
}

function StopWatch() {

    var startTime = undefined;
    var stopTime = undefined;
    var running = false;
    
   this.start = function(){
        
        if (running == true)
            return;
        
        if (stopTime != null)
            startTime += getTime() - stopTime;
        else
            startTime = getTime();
            
        running = true;    
    };
    
    this.reset = function() {
        startTime = getTime();
        stopTime = startTime;
    };
    
    this.stop = function(){
        
        if (running == false)
            return;    
        
        stopTime = getTime();
        running = false;
    };
    
    this.updateTime = function(t) {
        if (running == true) {
            startTime = getTime() - t*1000;
        } else {
            startTime = stopTime - t*1000;
        }
    };
    
    this.duration = function(){
        if (startTime == null)
            return 0;
        else {
            if (running)
                return (getTime() - startTime) / 1000;
            else
                return (stopTime - startTime) / 1000;
        }
    };
    
    this.durationFormatted = function(digits) {
        return formatDuration( this.duration(digits) );
    };
    
    
    this.isRunning = function() { return running; };
   
}
