// fanLibSwitcher: A module for swtiching between modules
var fanLibSwitcher = new function() {
	this.moduleId="fls";	// module id
	this.active=false;
	
	var camera = new FSCamera();
	var offset = new FSOffset();
	var orientation = new FSOrientation(0);
	
	var inited=false;
	var button=new FSModel('flsButton', 64);
	var buttons;
	var modules;
	var timer;
	var lastModuleCount;
	var timerOn = false;
	
	this.timedCount = function() {
		if (lastModuleCount != fanLib.modules.length) this.activate();
		timer=setTimeout("fanLibSwitcher.timedCount()",100);
	};

	this.startTimer = function() {
		if (!timerOn) {
			timerOn = true;
			this.timedCount();
		}
	};
	
	this.stopTimer = function() {
		clearTimeout(timer);
		timerOn = false;
	};
	
	this.init = function() {
		button.image = baseImgUrl+"fantalib_switcher_tab.png";
		button.x = 4460;
		button.y = 300;
		button.z = 1;
		inited = true;
	};
	
	this.activate = function() {
		camera.updatePosition();
		offset.updatePosition();
		orientation.updateOrientation();
		
		this.active = true;
		if (!inited) {
			this.init();
		}
		
		
		this.startTimer();
		
		
		modules = new Array();
		buttons = new Array();
		lastModuleCount = fanLib.modules.length;
		for (var i=0; i<fanLib.modules.length; i++) {
			if (typeof(fanLib.modules[i]['moduleIcon']) != 'undefined') {
				modules.push(fanLib.modules[i]);
				b = new FSModel("b"+i, 256, fsRoot);
				b.scaleX=0.29;
				b.scaleY=0.29;
				b.x = 82+155*i;
				b.y = 180;
				b.image = fanLib.modules[i].moduleIcon;
				buttons.push(b);
			}
		}
	};
	
	this.deactivate = function() {
		this.active = false;
		this.stopTimer();
		for (var i=0; i<buttons.length; i++) {
			buttons[i].clear();
		}
	};
	
	this.accel = function(x, y, z) {
		return true;
	};
	
	this.touch = function(type, x, y, id, area) {
		if (type == 'B') {
			if (button.hitTest(x+fanLib._camera.x-fanLib._offset.x,y+fanLib._camera.y-fanLib._offset.y)) {
					fanLib.activateModule(fanLibSwitcher);
				
				return false;
			}
			
			if (this.active) {
				for (var i=0; i<buttons.length;i++) {
					if (buttons[i].hitTest(x,y)) {
						fanLib.activateModule(modules[i]);
						return false;
					}
				}
				return false;
			}
		}
		return true;
	};
	
	this.camera = function(x,y) {
		switch (fanLib._orientation.orientation) {
			case 0:
				button.x = 20 + x;
				button.y = 460 + y;
				button.scaleX=-1;
				break;
			case 1:
				button.x = 460 + x;
				button.y = 300 + y;
				button.scaleX=1;
				break;
			case 2:
				button.x = 460 + x;
				button.y = 300 + y;
				button.scaleX=1;
				break;
		}
	};
	
	this.offset = function(x,y) {
		return false;
	};
	
	this.orientation = function(o) {
		this.camera(fanLib._camera.x, fanLib._camera.y);
		return false;
	};
};

fanLib.addModule(fanLibSwitcher, true);
fanLib.activateModule(fanLibSwitcher);